diff --git a/sway/input/cursor.c b/sway/input/cursor.c
index 9e567b5ce2..a5da94bd17 100644
--- a/sway/input/cursor.c
+++ b/sway/input/cursor.c
@@ -746,11 +746,11 @@ static void handle_tool_button(struct wl_listener *listener, void *data) {
 		(enum zwp_tablet_pad_v2_button_state)event->state);
 }
 
-static void check_constraint_region(struct sway_cursor *cursor) {
+static void check_constraint_region(struct sway_cursor *cursor, bool do_warp) {
 	struct wlr_pointer_constraint_v1 *constraint = cursor->active_constraint;
 	pixman_region32_t *region = &constraint->region;
 	struct sway_view *view = view_from_wlr_surface(constraint->surface);
-	if (view) {
+	if (view && do_warp) {
 		struct sway_container *con = view->container;
 
 		double sx = cursor->cursor->x - con->content_x + view->geometry.x;
@@ -786,7 +786,7 @@ static void handle_constraint_commit(struct wl_listener *listener,
 	struct wlr_pointer_constraint_v1 *constraint = cursor->active_constraint;
 	assert(constraint->surface == data);
 
-	check_constraint_region(cursor);
+	check_constraint_region(cursor, false);
 }
 
 static void handle_request_pointer_set_cursor(struct wl_listener *listener,
@@ -1279,7 +1279,10 @@ void sway_cursor_constrain(struct sway_cursor *cursor,
 			&constraint->surface->input_region);
 	}
 
-	check_constraint_region(cursor);
+	// Snapping to the constraint region should happen on the first surface commit
+	// and only on the first surface commit, but due to the FIXME above, we do it
+	// here instead.
+	check_constraint_region(cursor, true);
 
 	wlr_pointer_constraint_v1_send_activated(constraint);
 
